Module usbaxla_module
    ' USBee AX Toolbuilder
    '      usbaxla.dll Copyright 2005 CWAV www.usbee.com

    '--------------------------------------------
    '  Bit-Bang I/O 
    '   
    Declare Function SetSignals Lib "usbaxla" Alias "?SetSignals@@YGHEIPAE@Z" (ByVal State As Byte, ByVal Length As Integer, ByRef Buffer As Byte) As Integer
    '   
    Declare Function GetSignals Lib "usbaxla" Alias "?GetSignals@@YGHEIPAE@Z" (ByVal State As Byte, ByVal Length As Integer, ByRef Buffer As Byte) As Integer
    '   
    Declare Function SetMode Lib "usbaxla" Alias "?SetMode@@YGHH@Z" (ByVal mode As Byte) As Integer
    '--------------------------------------------
    '    
    '         (Logic Analyzer or Signal Generator)
    Declare Function MakeBuffer Lib "usbaxla" Alias "?MakeBuffer@@YGPAEK@Z" (ByVal Size As Integer) As Integer
    '      - 
    Declare Function MakeBuffer16 Lib "usbaxla" Alias "?MakeBuffer16@@YGPAEK@Z" (ByVal Size As Integer) As Integer
    '       (   MakeBuffer16)
    Declare Function MakeBufferScope Lib "usbaxla" Alias "?MakeBufferScope@@YGPAEK@Z" (ByVal Size As Integer) As Integer
    '     
    Declare Function DeleteBuffer Lib "usbaxla" Alias "?DeleteBuffer@@YGHPAE@Z" (ByVal Buffer As Integer) As Integer
    '  - 
    Declare Function DeleteBuffer16 Lib "usbaxla" Alias "?DeleteBuffer16@@YGHPAE@Z" (ByVal Buffer As Integer) As Integer
    '   
    Declare Function SetData Lib "usbaxla" Alias "?SetData@@YGJKE@Z" (ByVal Index As Integer, ByVal Value As Byte) As Integer
    '--------------------------------------------
    '   
    '   USBee AX-Pro pods   
    Declare Function EnumerateAXPods Lib "usbaxla" Alias "?EnumerateAXPods@@YGHPAI@Z" (ByRef Source As Integer) As Integer
    '   .    .
    Declare Function InitializeAXPod Lib "usbaxla" Alias "?InitializeAXPod@@YGHI@Z" (ByVal PodID As Integer) As Integer
    '--------------------------------------------
    '   
    '      (Logic Analyzer)
    Declare Function StartCapture Lib "usbaxla" Alias "?StartCapture@@YGHIIPAEH0KK@Z" (ByVal SampleRate As Integer, ByVal ClockMode As Integer, ByRef Triggers As Byte, ByVal TriggerNumber As Integer, ByVal Buffer As Integer, ByVal Length As Integer, ByVal PostStore As Integer) As Integer
    '      (Logic Analyzer)
    Declare Function StopCapture Lib "usbaxla" Alias "?StopCapture@@YGHXZ" () As Integer
    '       
    Declare Function CaptureStatus Lib "usbaxla" Alias "?CaptureStatus@@YGHPAD00PAJ110@Z" (ByRef Breaks As Byte, ByRef Running As Byte, ByRef Triggered As Byte, ByRef StartP As Integer, ByRef EndP As Integer, ByRef Trigger As Integer, ByRef Full As Byte) As Integer
    '      
    Declare Function SpeedTest Lib "usbaxla" Alias "?SpeedTest@@YGHXZ" () As Integer
    Declare Function SpeedTest16 Lib "usbaxla" Alias "?SpeedTest16@@YGHXZ" () As Integer
    '--------------------------------------------
    '   
    '   
    Declare Function GenerateStatus Lib "usbaxla" Alias "?GenerateStatus@@YGHPAD000@Z" (ByRef Breaks As Byte, ByRef Running As Byte, ByRef Triggered As Byte, ByRef Complete As Byte) As Integer
    '      
    Declare Function StopGenerate Lib "usbaxla" Alias "?StopGenerate@@YGHXZ" () As Integer
    '   
    Declare Function StartGenerate Lib "usbaxla" Alias "?StartGenerate@@YGHIEPAEK@Z" (ByVal SampleRate As Integer, ByVal TriggerMode As Byte, ByVal Buffer As Integer, ByVal Length As Integer) As Integer
    '--------------------------------------------
    '    
    '     
    Declare Function StartCaptureMSO Lib "usbaxla" Alias "?StartCaptureMSO@@YGHIIIIIPAEH00KK@Z" (ByVal Channel As Integer, ByVal Slope As Integer, ByVal Level As Integer, ByVal SampleRate As Integer, ByVal ClockMode As Integer, ByRef Triggers As Byte, ByVal TriggerNumber As Integer, ByVal Buffer As Integer, ByVal ScopeBuffer As Integer, ByVal Length As Integer, ByVal PostStore As Integer) As Integer
    '     
    Declare Function StopCaptureMSO Lib "usbaxla" Alias "?StopCaptureMSO@@YGHXZ" () As Integer
    '--------------------------------------------
    '   
    '       
    Declare Function GetAnalogAverageCount Lib "usbaxla" Alias "?GetAnalogAverageCount@@YGKK@Z" (ByVal Channel As Integer) As Integer

    Declare Function ScopeData Lib "usbaxla" Alias "?ScopeData@@YGJJ@Z" (ByVal Index As Integer) As Integer
    Declare Function LoggedData Lib "usbaxla" Alias "?LoggedData@@YGJK@Z" (ByVal Index As Integer) As Integer

    '--------------------------------------------
    '  Windows
    '   
    Declare Function GetTickCount Lib "kernel32" () As Integer

    '--------------------------------------------
    '     
    ' Bit-Bang I/O  GetSignal  SetSignal
    Public Const FAST_ONEWAY_DATA As Short = 1
    Public Const SLOW_TWOWAY_DATA As Short = 0

    Public Const DATA_CHANGES_ON_RISING_EDGE As Short = 2
    Public Const DATA_CHANGES_ON_FALLING_EDGE As Short = 0
    Public Const DATA_IS_SAMPLED_ON_RISING_EDGE As Short = 0
    Public Const DATA_IS_SAMPLED_ON_FALLING_EDGE As Short = 2

    Public Const C_24MHz As Short = (0 * 4) '00000000
    Public Const C_12MHz As Short = (1 * 4) '00000100
    Public Const C_6MHz As Short = (2 * 4)  '00001000
    Public Const C_3MHz As Short = (3 * 4)  '00001100
    Public Const C_1MHz As Short = (4 * 4)  '00010000
    '----------------------------------------------------
    '      
    Public Const DONT_CARE_TRIGGER As Short = 0
    Public Const RISING_EDGE_TRIGGER As Short = 1
    Public Const FALLING_EDGE_TRIGGER As Short = 2
    Public Const HIGH_LEVEL_TRIGGER As Short = 3
    Public Const LOW_LEVEL_TRIGGER As Short = 4
    '---------------------------------------------------------
    '      
    Public Const CHANNEL1 As Short = 1
    Public Const CHANNEL2 As Short = 2

    Public Const DONT_CARE_SLOPE As Short = 0
    Public Const RISING_EDGE_SLOPE As Short = 1
    Public Const FALLING_EDGE__SLOPE As Short = 2
    '----------------------------------------------------
    Public RateVal As Byte              '  
    Public Slope As Integer             '     ( ,  , )
    Public Level As Integer             '      (   * &H100000)
    Public NumberOfSamples As Integer   '   
    Public BigBuffer As Integer         '      
    Public ScopeBigBuffer As Integer    '      
    Public Triggers(256) As Byte        '    
    Public TriggerStates As Integer     '    
    Public ReturnVal As Integer         '    Status
    Public TRunning As Byte             '    ?
    Public TBreaks As Byte              '    ? (   )
    Public TTriggered As Byte           '   ?
    Public TStartP As Integer           '   
    Public TEndP As Integer             '   
    Public TTrigger As Integer          '  
    Public TFull As Byte                '  (0...100%)
    Function VoltsToCounts(ByRef Volts As Single) As Byte
        Dim Counts As Byte
        Counts = ((Volts + 10.0#) / 0.078125)
        VoltsToCounts = Counts
    End Function
    Function CountsToVolts(ByRef Counts As Single) As Single
        Dim Volts As Double
        Volts = (Counts * 0.078125) - 10.0#
        CountsToVolts = Volts
    End Function
    Sub DelayMS(ByRef delay As Integer)
        Dim OldTime As Long
        OldTime = GetTickCount
        While (GetTickCount - OldTime) < delay
            System.Windows.Forms.Application.DoEvents()
        End While
    End Sub
End Module